# coding: utf-8

"""
    Google Drive API

    The Google Drive API allows clients to access resources from Google Drive.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class TeamDriveCapabilities(BaseModel):
    """
    Capabilities the current user has on this Team Drive.
    """ # noqa: E501
    can_add_children: Optional[StrictBool] = Field(default=None, description="Whether the current user can add children to folders in this Team Drive.", alias="canAddChildren")
    can_change_copy_requires_writer_permission_restriction: Optional[StrictBool] = Field(default=None, description="Whether the current user can change the `copyRequiresWriterPermission` restriction of this Team Drive.", alias="canChangeCopyRequiresWriterPermissionRestriction")
    can_change_domain_users_only_restriction: Optional[StrictBool] = Field(default=None, description="Whether the current user can change the `domainUsersOnly` restriction of this Team Drive.", alias="canChangeDomainUsersOnlyRestriction")
    can_change_sharing_folders_requires_organizer_permission_restriction: Optional[StrictBool] = Field(default=None, description="Whether the current user can change the `sharingFoldersRequiresOrganizerPermission` restriction of this Team Drive.", alias="canChangeSharingFoldersRequiresOrganizerPermissionRestriction")
    can_change_team_drive_background: Optional[StrictBool] = Field(default=None, description="Whether the current user can change the background of this Team Drive.", alias="canChangeTeamDriveBackground")
    can_change_team_members_only_restriction: Optional[StrictBool] = Field(default=None, description="Whether the current user can change the `teamMembersOnly` restriction of this Team Drive.", alias="canChangeTeamMembersOnlyRestriction")
    can_comment: Optional[StrictBool] = Field(default=None, description="Whether the current user can comment on files in this Team Drive.", alias="canComment")
    can_copy: Optional[StrictBool] = Field(default=None, description="Whether the current user can copy files in this Team Drive.", alias="canCopy")
    can_delete_children: Optional[StrictBool] = Field(default=None, description="Whether the current user can delete children from folders in this Team Drive.", alias="canDeleteChildren")
    can_delete_team_drive: Optional[StrictBool] = Field(default=None, description="Whether the current user can delete this Team Drive. Attempting to delete the Team Drive may still fail if there are untrashed items inside the Team Drive.", alias="canDeleteTeamDrive")
    can_download: Optional[StrictBool] = Field(default=None, description="Whether the current user can download files in this Team Drive.", alias="canDownload")
    can_edit: Optional[StrictBool] = Field(default=None, description="Whether the current user can edit files in this Team Drive", alias="canEdit")
    can_list_children: Optional[StrictBool] = Field(default=None, description="Whether the current user can list the children of folders in this Team Drive.", alias="canListChildren")
    can_manage_members: Optional[StrictBool] = Field(default=None, description="Whether the current user can add members to this Team Drive or remove them or change their role.", alias="canManageMembers")
    can_read_revisions: Optional[StrictBool] = Field(default=None, description="Whether the current user can read the revisions resource of files in this Team Drive.", alias="canReadRevisions")
    can_remove_children: Optional[StrictBool] = Field(default=None, description="Deprecated: Use `canDeleteChildren` or `canTrashChildren` instead.", alias="canRemoveChildren")
    can_rename: Optional[StrictBool] = Field(default=None, description="Whether the current user can rename files or folders in this Team Drive.", alias="canRename")
    can_rename_team_drive: Optional[StrictBool] = Field(default=None, description="Whether the current user can rename this Team Drive.", alias="canRenameTeamDrive")
    can_reset_team_drive_restrictions: Optional[StrictBool] = Field(default=None, description="Whether the current user can reset the Team Drive restrictions to defaults.", alias="canResetTeamDriveRestrictions")
    can_share: Optional[StrictBool] = Field(default=None, description="Whether the current user can share files or folders in this Team Drive.", alias="canShare")
    can_trash_children: Optional[StrictBool] = Field(default=None, description="Whether the current user can trash children from folders in this Team Drive.", alias="canTrashChildren")
    __properties: ClassVar[List[str]] = ["canAddChildren", "canChangeCopyRequiresWriterPermissionRestriction", "canChangeDomainUsersOnlyRestriction", "canChangeSharingFoldersRequiresOrganizerPermissionRestriction", "canChangeTeamDriveBackground", "canChangeTeamMembersOnlyRestriction", "canComment", "canCopy", "canDeleteChildren", "canDeleteTeamDrive", "canDownload", "canEdit", "canListChildren", "canManageMembers", "canReadRevisions", "canRemoveChildren", "canRename", "canRenameTeamDrive", "canResetTeamDriveRestrictions", "canShare", "canTrashChildren"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TeamDriveCapabilities from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TeamDriveCapabilities from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "canAddChildren": obj.get("canAddChildren"),
            "canChangeCopyRequiresWriterPermissionRestriction": obj.get("canChangeCopyRequiresWriterPermissionRestriction"),
            "canChangeDomainUsersOnlyRestriction": obj.get("canChangeDomainUsersOnlyRestriction"),
            "canChangeSharingFoldersRequiresOrganizerPermissionRestriction": obj.get("canChangeSharingFoldersRequiresOrganizerPermissionRestriction"),
            "canChangeTeamDriveBackground": obj.get("canChangeTeamDriveBackground"),
            "canChangeTeamMembersOnlyRestriction": obj.get("canChangeTeamMembersOnlyRestriction"),
            "canComment": obj.get("canComment"),
            "canCopy": obj.get("canCopy"),
            "canDeleteChildren": obj.get("canDeleteChildren"),
            "canDeleteTeamDrive": obj.get("canDeleteTeamDrive"),
            "canDownload": obj.get("canDownload"),
            "canEdit": obj.get("canEdit"),
            "canListChildren": obj.get("canListChildren"),
            "canManageMembers": obj.get("canManageMembers"),
            "canReadRevisions": obj.get("canReadRevisions"),
            "canRemoveChildren": obj.get("canRemoveChildren"),
            "canRename": obj.get("canRename"),
            "canRenameTeamDrive": obj.get("canRenameTeamDrive"),
            "canResetTeamDriveRestrictions": obj.get("canResetTeamDriveRestrictions"),
            "canShare": obj.get("canShare"),
            "canTrashChildren": obj.get("canTrashChildren")
        })
        return _obj


