# coding: utf-8

"""
    Google Drive API

    The Google Drive API allows clients to access resources from Google Drive.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class User(BaseModel):
    """
    Information about a Drive user.
    """ # noqa: E501
    display_name: Optional[StrictStr] = Field(default=None, description="Output only. A plain text displayable name for this user.", alias="displayName")
    email_address: Optional[StrictStr] = Field(default=None, description="Output only. The email address of the user. This may not be present in certain contexts if the user has not made their email address visible to the requester.", alias="emailAddress")
    kind: Optional[StrictStr] = Field(default='drive#user', description="Output only. Identifies what kind of resource this is. Value: the fixed string `\"drive#user\"`.")
    me: Optional[StrictBool] = Field(default=None, description="Output only. Whether this user is the requesting user.")
    permission_id: Optional[StrictStr] = Field(default=None, description="Output only. The user's ID as visible in Permission resources.", alias="permissionId")
    photo_link: Optional[StrictStr] = Field(default=None, description="Output only. A link to the user's profile photo, if available.", alias="photoLink")
    __properties: ClassVar[List[str]] = ["displayName", "emailAddress", "kind", "me", "permissionId", "photoLink"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of User from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of User from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "displayName": obj.get("displayName"),
            "emailAddress": obj.get("emailAddress"),
            "kind": obj.get("kind") if obj.get("kind") is not None else 'drive#user',
            "me": obj.get("me"),
            "permissionId": obj.get("permissionId"),
            "photoLink": obj.get("photoLink")
        })
        return _obj


